/*-----------------------------------------------
 * Root
-------------------------------------------------*/
var root = $("body").data('root');
var page = $("body").data('page');


/*-----------------------------------------------
 * COMMON
-------------------------------------------------*/
$(function(){

	// Anchor Smooth Scroll
	$('.js-anchor').on('click', function(){
		var speed = 1000;
		var href= $(this).attr("href");
		var target = $(href == "#" || href == "" ? 'html' : href);
		var position = target.offset().top;
		$('body,html').animate({scrollTop:position}, speed, 'easeOutQuart');
		return false;
	});

	$('.js-anchorLeft').on('click', function(){
		var speed = 1000;
		var href= $(this).attr("href");
		var target = $(href == "#" || href == "" ? 'html' : href);
		var position = target.offset().left;
		if(href == '#movie'){
			var ww = window.innerWidth;
			position = target.offset().left + ww/2 + 200;
		}
		$('body,html').animate({scrollLeft:position}, speed, 'easeOutQuart');
		return false;
	})

	// Menu
	$('.js-menu').on('click', function(){
		$(this).toggleClass('is-active');
		
		if($(this).hasClass('is-active')){
			$('.js-header').addClass('is-active');
		} else {
			$('.js-header').removeClass('is-active');
		}
	});

	$("a.headerNavLists__link, a.headerSNSList__link").on('click',function(){
		$('.js-menu').removeClass('is-active');
		$('.js-header').removeClass('is-active');
	});


	/**
	 * Modal open
	 */
	// Common
	$('.js-modalOpen').on('click', function(){
		var modalID = $(this).data('modal');
		$('#' + modalID).fadeIn(500);
		$('.modalBox').fadeIn(500);
		$('body').css({'overflow':'hidden'});
	});

	// Youtube
	$('.js-youtubePlay').on('click', function(){
		var ytID = $(this).data('ytid');
		var ytURL = 'https://www.youtube.com/embed/'+ytID+'?autoplay=1&rel=0';
		setTimeout(function(){
			$('.js-youtubeIframe').attr('src',ytURL);
		},100);
	});


	/**
	 * Modal close
	 * iframeのsrcをcloseの際に消す
	 */
	var $modalIF = $('.js-youtubeIframe');

	// Close処理
	function modalClose() {
		$('.modalBox, .oneModal').fadeOut(500);
		setTimeout(function(){
			$modalIF.attr('src','');
		},500);
		$('body').css({'overflow':''});
		if(page = 'top'){
			lenis.start();
			chk_wheelmove = true;
		}
	}

	// Closeボタン
	$('.js-modalClose').on('click', function(){
		modalClose();
	});

	// Close エリア外
	$('.js-oneModalIn').on('click touchend', function(e) {
		if (!$(e.target).closest('.js-oneModalIn__cont').length) {
			modalClose();
		}
	});

	// アクセス時自動モーダル
	// if($("#test")[0]){
	// 	$("#test").click()
	// }


});


/*-----------------------------------------------
 * ACCESS HISTORY [セッションストレージを使用して初回アクセスか判定するやつ]
----------------------------------------------- */
function accessHistory() {
	const keyName = 'visited';
	const keyValue = true;
	if (!sessionStorage.getItem(keyName)) {
		//FIRST ACCESS
		sessionStorage.setItem(keyName, keyValue);
		return true;
	} else {
		$('body').addClass('is-visited'); 
		return false;
	}
}
$(document).ready(accessHistory());


/*-----------------------------------------------
 * ScrollAnimation for IntersectionObserver [.js-scrani 要素が見えたら is-ani をaddclass するやつ]
-------------------------------------------------*/
const set_scrani = () =>{
	const SCRANI_ACTIVE_CLASSNAME = 'is-ani';
	const scrani_callback = (entries) => {
		//各 entry（IntersectionObserverEntry オブジェクト）に対して
		entries.forEach( (entry) => {
			//監視対象の要素が領域内に入った場合の処理
			if (entry.isIntersecting) {
				//監視対象の要素（entry.target）に is-ani クラスを追加
				entry.target.classList.add(SCRANI_ACTIVE_CLASSNAME);
			// }else{
			// 	entry.target.classList.remove(SCRANI_ACTIVE_CLASSNAME);
			}
		});
	}
	const scrani_option = {
		rootMargin: '-30% 0px',
	}
	const scrani_observer = new IntersectionObserver(scrani_callback, scrani_option);

	const target_scrani = document.querySelectorAll('.js-scrani');
	//全ての監視対象要素を observe() メソッドに指定
	target_scrani.forEach( (elem) => {
		//observe() に監視対象の要素を指定
		scrani_observer.observe(elem);
	});
}
if(page !== "top"){
	setTimeout(function(){
		set_scrani();
	},200);
}




/*-----------------------------------------------
 * MOVIE
-------------------------------------------------*/
function movie(_ytid,_option){
	$('#youtubeModal').fadeIn(500);
	if(_option){
		$("#youtubeModal").attr('data-option',_option);
	}else{
		$("#youtubeModal").attr('data-option','');
	}
	$('.modalBox').fadeIn(500);
	var ytURL = 'https://www.youtube.com/embed/'+_ytid+'?autoplay=1&rel=0';
	setTimeout(function(){
		$('.js-youtubeIframe').attr('src',ytURL);
	},100);
	$('body').css({'overflow':'hidden'});
	if(page = 'top'){
		lenis.stop();
		chk_wheelmove = false;
	}
}

// YouTube Iframe 二重再生防止 [movie1つのみ]
$(".js-moviePlay").on('click', function(){
	// if(page = 'top'){
	// 	player.stopVideo();
	// }
	$('body').addClass('--yt-apmov-stop');
	$(".js-modalBox").addClass('js-modalplayClose');
});

$(document).on('click','.js-modalplayClose a.js-modalClose', function(){
	// if(page = 'top'){
	// 	player.playVideo();
	// }
	$(".modalBox").removeClass('js-modalplayClose');
	$('body').removeClass('--yt-apmov-stop');
	$("#youtubeModal").attr('data-option','');
});

$(document).on('click','.js-modalplayClose .js-oneModalIn', function(e) {
	// if(page = 'top'){
	// 	player.playVideo();
	// }
	$(".modalBox").removeClass('js-modalplayClose');
	$('body').removeClass('--yt-apmov-stop');
});


/*-----------------------------------------------
 * Comment Modal
-------------------------------------------------*/
function comment(_comment){
	$("#js-commentModalCont").load(root+'_inc/page/comment/'+_comment+'.comment.html',function(){
		$("#commentModal").fadeIn(500);
		$(".modalBox").fadeIn(500);
		$("body").css({'overflow':'hidden'});
		if(page = 'top'){
			lenis.stop();
			chk_wheelmove = false;
		}
	});
}




/*-----------------------------------------------
 * movieBGPlayer
-------------------------------------------------*/
const movieBGVideo = $('.js-movieBgVideo').get(0);
function movieBGVideoPlayer(_config){
	if(_config == 'play'){
		movieBGVideo.play();
		 //console.log('movie=>PLAY');
	}
	if(_config == 'pause'){
		movieBGVideo.pause();
		// console.log('movie=>PAUSE');
	}
}


/*-----------------------------------------------
 * CLOCK
-------------------------------------------------*/
function zeroPadding(_num, _length){
	return ( Array(_length).join('0') + _num ).slice( -_length );
}
function meridiemCheck(_num){
	if(_num >= 13){
		return ( Array('PM'));
	}else{
		return ( Array('AM'));
	}
}
function hourDataset(_num){
	let targetElement = document.body;
	targetElement.dataset.timeH = _num;
}
function hour12(_num){
	if(_num >= 13){
		let calc_hour12 = _num - 12;
		return ( Number(calc_hour12));
	}else{
		return ( Number(_num));
	}
}
$(function(){
	$.ajax({
		type: 'GET',
		cache:false
	}).done(function(data,status,xhr){
		var dTime,dmeridiem,cHour,dHour,dMinute,dSec,dFull;
		var nowTime = new Date(xhr.getResponseHeader('Date'));
		var sTime = nowTime.getTime();
		setInterval(()=>{
			sTime = sTime + 1000;
			dTime = new Date(sTime);
			dmeridiem = meridiemCheck(dTime.getHours());
			hourDataset(dTime.getHours());
			cHour = hour12(dTime.getHours());
			dHour = zeroPadding(cHour,2);
			dMinute = zeroPadding(dTime.getMinutes(),2);
			dSec = zeroPadding(dTime.getSeconds(),2);
			dFull = dmeridiem+' '+dHour+':'+dMinute;
			$("#js-nowTime").text(dFull);
		},1000);
	});
});